# Interface RandomGenerator.ArbitrarilyJumpableGenerator

All Superinterfaces:
  `RandomGenerator, RandomGenerator.JumpableGenerator, RandomGenerator.LeapableGenerator, RandomGenerator.StreamableGenerator`

Enclosing interface:
  `RandomGenerator`

public static interface RandomGenerator.ArbitrarilyJumpableGenerator extends RandomGenerator.LeapableGenerator
This interface is designed to provide a common protocol for objects that generate sequences of pseudorandom values and can easily jump forward, by an arbitrary amount, to a distant point in the state cycle.

Ideally, all `RandomGenerator.ArbitrarilyJumpableGenerator` objects produced by iterative jumping from a single original `RandomGenerator.ArbitrarilyJumpableGenerator` object are statistically independent of one another and individually uniform, provided that they do not traverse overlapping portions of the state cycle. In practice, one must settle for some approximation to independence and uniformity. In particular, a specific implementation may assume that each generator in a stream produced by the `jump`() method is used to produce a number of values no larger than the jump distance specified. Implementors are advised to use algorithms whose period is at least 2127.

For many applications, it suffices to jump forward by a power of two or some small multiple of a power of two, but this power of two may not be representable as a `long` value. To avoid the use of `BigInteger` values as jump distances, `double` values are used instead.

Methods are provided to perform a single jump operation and also to produce a stream of generators produced from the original by iterative copying and jumping of internal state. A typical strategy for a multithreaded application is to create a single `RandomGenerator.ArbitrarilyJumpableGenerator` object, call its `jump`() method exactly once, and then parcel out generators from the resulting stream, one to each thread. However, each generator produced also has type `RandomGenerator.ArbitrarilyJumpableGenerator`; with care, different jump distances can be used to traverse the entire state cycle in various ways.

Objects that implement `RandomGenerator.ArbitrarilyJumpableGenerator` are typically not cryptographically secure. Consider instead using `SecureRandom` to get a cryptographically secure pseudo-random number generator for use by security-sensitive applications.

Since:
  17

- ## Nested Class Summary

  ### Nested classes/interfaces declared in interface RandomGenerator

  `RandomGenerator.ArbitrarilyJumpableGenerator, RandomGenerator.JumpableGenerator, RandomGenerator.LeapableGenerator, RandomGenerator.SplittableGenerator, RandomGenerator.StreamableGenerator`
  Modifier and Type
  Interface
  Description
  `static interface`
  `RandomGenerator.ArbitrarilyJumpableGenerator`
  This interface is designed to provide a common protocol for objects that generate sequences of pseudorandom values and can easily jump forward, by an arbitrary amount, to a distant point in the state cycle.
  `static interface`
  `RandomGenerator.JumpableGenerator`
  This interface is designed to provide a common protocol for objects that generate pseudorandom values and can easily jump forward, by a moderate amount (ex. 264) to a distant point in the state cycle.
  `static interface`
  `RandomGenerator.LeapableGenerator`
  This interface is designed to provide a common protocol for objects that generate sequences of pseudorandom values and can easily not only jump but also leap forward, by a large amount (ex. 2128), to a very distant point in the state cycle.
  `static interface`
  `RandomGenerator.SplittableGenerator`
  This interface is designed to provide a common protocol for objects that generate sequences of pseudorandom values and can be split into two objects (the original one and a new one) each of which obey that same protocol (and therefore can be recursively split indefinitely).
  `static interface`
  `RandomGenerator.StreamableGenerator`
  The `RandomGenerator.StreamableGenerator` interface augments the `RandomGenerator` interface to provide methods that return streams of `RandomGenerator` objects.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `RandomGenerator.ArbitrarilyJumpableGenerator`
  `copy()`
  Returns a new generator whose internal state is an exact copy of this generator (therefore their future behavior should be identical if subjected to the same series of operations).
  `default RandomGenerator.ArbitrarilyJumpableGenerator`
  `copyAndJump(double distance)`
  Copy this generator, jump this generator forward, then return the copy.
  `default void`
  `jump()`
  Alter the state of this pseudorandom number generator so as to jump forward a large, fixed distance (typically 264 or more) within its state cycle.
  `void`
  `jump(double distance)`
  Alter the state of this pseudorandom number generator so as to jump forward a specified distance within its state cycle.
  `void`
  `jumpPowerOfTwo(int logDistance)`
  Alter the state of this pseudorandom number generator so as to jump forward a distance equal to 2`logDistance` within its state cycle.
  `default Stream<RandomGenerator.ArbitrarilyJumpableGenerator>`
  `jumps(double distance)`
  Returns an effectively unlimited stream of new pseudorandom number generators, each of which implements the `RandomGenerator.ArbitrarilyJumpableGenerator` interface, produced by jumping copies of this generator by different integer multiples of the specified jump distance.
  `default Stream<RandomGenerator.ArbitrarilyJumpableGenerator>`
  `jumps(long streamSize, double distance)`
  Returns a stream producing the given `streamSize` number of new pseudorandom number generators, each of which implements the `RandomGenerator.ArbitrarilyJumpableGenerator` interface, produced by jumping copies of this generator by different integer multiples of the specified jump distance.
  `default void`
  `leap()`
  Alter the state of this pseudorandom number generator so as to jump forward a very large, fixed distance (typically 2128 or more) within its state cycle.
  `static RandomGenerator.ArbitrarilyJumpableGenerator`
  `of(String name)`
  Returns an instance of `RandomGenerator.ArbitrarilyJumpableGenerator` that utilizes the `name` algorithm.

  ### Methods declared in interface RandomGenerator

  `doubles, doubles, doubles, doubles, equiDoubles, ints, ints, ints, ints, isDeprecated, longs, longs, longs, longs, nextBoolean, nextBytes, nextDouble, nextDouble, nextDouble, nextExponential, nextFloat, nextFloat, nextFloat, nextGaussian, nextGaussian, nextInt, nextInt, nextInt, nextLong, nextLong, nextLong`
  Modifier and Type
  Method
  Description
  `default DoubleStream`
  `doubles()`
  Returns an effectively unlimited stream of pseudorandomly chosen `double` values.
  `default DoubleStream`
  `doubles(double randomNumberOrigin, double randomNumberBound)`
  Returns an effectively unlimited stream of pseudorandomly chosen `double` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
  `default DoubleStream`
  `doubles(long streamSize)`
  Returns a stream producing the given `streamSize` number of pseudorandomly chosen `double` values.
  `default DoubleStream`
  `doubles(long streamSize, double randomNumberOrigin, double randomNumberBound)`
  Returns a stream producing the given `streamSize` number of pseudorandomly chosen `double` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
  `default DoubleStream`
  `equiDoubles(double left, double right, boolean isLeftIncluded, boolean isRightIncluded)`
  Returns an effectively unlimited stream of pseudorandomly chosen `double` values, where each value is between the specified `left` boundary and the specified `right` boundary.
  `default IntStream`
  `ints()`
  Returns an effectively unlimited stream of pseudorandomly chosen `int` values.
  `default IntStream`
  `ints(int randomNumberOrigin, int randomNumberBound)`
  Returns an effectively unlimited stream of pseudorandomly chosen `int` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
  `default IntStream`
  `ints(long streamSize)`
  Returns a stream producing the given `streamSize` number of pseudorandomly chosen `int` values.
  `default IntStream`
  `ints(long streamSize, int randomNumberOrigin, int randomNumberBound)`
  Returns a stream producing the given `streamSize` number of pseudorandomly chosen `int` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
  `default boolean`
  `isDeprecated()`
  Return true if the implementation of RandomGenerator (algorithm) has been marked for deprecation.
  `default LongStream`
  `longs()`
  Returns an effectively unlimited stream of pseudorandomly chosen `long` values.
  `default LongStream`
  `longs(long streamSize)`
  Returns a stream producing the given `streamSize` number of pseudorandomly chosen `long` values.
  `default LongStream`
  `longs(long randomNumberOrigin, long randomNumberBound)`
  Returns an effectively unlimited stream of pseudorandomly chosen `long` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
  `default LongStream`
  `longs(long streamSize, long randomNumberOrigin, long randomNumberBound)`
  Returns a stream producing the given `streamSize` number of pseudorandomly chosen `long` values, where each value is between the specified origin (inclusive) and the specified bound (exclusive).
  `default boolean`
  `nextBoolean()`
  Returns a pseudorandomly chosen `boolean` value.
  `default void`
  `nextBytes(byte[] bytes)`
  Fills a user-supplied byte array with generated byte values pseudorandomly chosen uniformly from the range of values between -128 (inclusive) and 127 (inclusive).
  `default double`
  `nextDouble()`
  Returns a pseudorandom `double` value between zero (inclusive) and one (exclusive).
  `default double`
  `nextDouble(double bound)`
  Returns a pseudorandomly chosen `double` value between zero (inclusive) and the specified bound (exclusive).
  `default double`
  `nextDouble(double origin, double bound)`
  Returns a pseudorandomly chosen `double` value between the specified origin (inclusive) and the specified bound (exclusive).
  `default double`
  `nextExponential()`
  Returns a nonnegative `double` value pseudorandomly chosen from an exponential distribution whose mean is 1.
  `default float`
  `nextFloat()`
  Returns a pseudorandom `float` value between zero (inclusive) and one (exclusive).
  `default float`
  `nextFloat(float bound)`
  Returns a pseudorandomly chosen `float` value between zero (inclusive) and the specified bound (exclusive).
  `default float`
  `nextFloat(float origin, float bound)`
  Returns a pseudorandomly chosen `float` value between the specified origin (inclusive) and the specified bound (exclusive).
  `default double`
  `nextGaussian()`
  Returns a `double` value pseudorandomly chosen from a Gaussian (normal) distribution whose mean is 0 and whose standard deviation is 1.
  `default double`
  `nextGaussian(double mean, double stddev)`
  Returns a `double` value pseudorandomly chosen from a Gaussian (normal) distribution with a mean and standard deviation specified by the arguments.
  `default int`
  `nextInt()`
  Returns a pseudorandomly chosen `int` value.
  `default int`
  `nextInt(int bound)`
  Returns a pseudorandomly chosen `int` value between zero (inclusive) and the specified bound (exclusive).
  `default int`
  `nextInt(int origin, int bound)`
  Returns a pseudorandomly chosen `int` value between the specified origin (inclusive) and the specified bound (exclusive).
  `long`
  `nextLong()`
  Returns a pseudorandomly chosen `long` value.
  `default long`
  `nextLong(long bound)`
  Returns a pseudorandomly chosen `long` value between zero (inclusive) and the specified bound (exclusive).
  `default long`
  `nextLong(long origin, long bound)`
  Returns a pseudorandomly chosen `long` value between the specified origin (inclusive) and the specified bound (exclusive).

  ### Methods declared in interface RandomGenerator.JumpableGenerator

  `copyAndJump, jumpDistance, jumps, jumps, rngs, rngs`
  Modifier and Type
  Method
  Description
  `default RandomGenerator`
  `copyAndJump()`
  Copy this generator, jump this generator forward, then return the copy.
  `double`
  `jumpDistance()`
  Returns the distance by which the `jump`() method will jump forward within the state cycle of this generator object.
  `default Stream<RandomGenerator>`
  `jumps()`
  Returns an effectively unlimited stream of new pseudorandom number generators, each of which implements the `RandomGenerator` interface.
  `default Stream<RandomGenerator>`
  `jumps(long streamSize)`
  Returns a stream producing the given `streamSize` number of new pseudorandom number generators, each of which implements the `RandomGenerator` interface.
  `default Stream<RandomGenerator>`
  `rngs()`
  Returns an effectively unlimited stream of new pseudorandom number generators, each of which implements the `RandomGenerator` interface.
  `default Stream<RandomGenerator>`
  `rngs(long streamSize)`
  Returns a stream producing the given `streamSize` number of new pseudorandom number generators, each of which implements the `RandomGenerator` interface.

  ### Methods declared in interface RandomGenerator.LeapableGenerator

  `copyAndLeap, leapDistance, leaps, leaps`
  Modifier and Type
  Method
  Description
  `default RandomGenerator.JumpableGenerator`
  `copyAndLeap()`
  Copy this generator, leap this generator forward, then return the copy.
  `double`
  `leapDistance()`
  Returns the distance by which the `leap`() method will leap forward within the state cycle of this generator object.
  `default Stream<RandomGenerator.JumpableGenerator>`
  `leaps()`
  Returns an effectively unlimited stream of new pseudorandom number generators, each of which implements the `RandomGenerator.JumpableGenerator` interface.
  `default Stream<RandomGenerator.JumpableGenerator>`
  `leaps(long streamSize)`
  Returns a stream producing the given `streamSize` number of new pseudorandom number generators, each of which implements the `RandomGenerator.JumpableGenerator` interface.

- ## Method Details

  - ### of

    static RandomGenerator.ArbitrarilyJumpableGenerator of(String name)
    Returns an instance of `RandomGenerator.ArbitrarilyJumpableGenerator` that utilizes the `name` algorithm.
    Parameters:
      `name` - Name of random number generator algorithm
    Returns:
      An instance of `RandomGenerator.ArbitrarilyJumpableGenerator`
    Throws:
      `NullPointerException` - if name is null
      `IllegalArgumentException` - if the named algorithm is not found

  - ### copy

    RandomGenerator.ArbitrarilyJumpableGenerator copy()
    Returns a new generator whose internal state is an exact copy of this generator (therefore their future behavior should be identical if subjected to the same series of operations).
    Specified by:
      `copy` in interface `RandomGenerator.JumpableGenerator`
    Specified by:
      `copy` in interface `RandomGenerator.LeapableGenerator`
    Returns:
      a new object that is a copy of this generator

  - ### jumpPowerOfTwo

    void jumpPowerOfTwo(int logDistance)
    Alter the state of this pseudorandom number generator so as to jump forward a distance equal to 2`logDistance` within its state cycle.
    Parameters:
      `logDistance` - the base-2 logarithm of the distance to jump forward within the state cycle
    Throws:
      `IllegalArgumentException` - if `logDistance` is 2`logDistance` is greater than the period of this generator

  - ### jump

    void jump(double distance)
    Alter the state of this pseudorandom number generator so as to jump forward a specified distance within its state cycle.
    Parameters:
      `distance` - the distance to jump forward within the state cycle
    Throws:
      `IllegalArgumentException` - if `distance` is not greater than or equal to 0.0, or is greater than the period of this generator

  - ### jump

    default void jump()
    Alter the state of this pseudorandom number generator so as to jump forward a large, fixed distance (typically 264 or more) within its state cycle. The distance used is that returned by method `jumpDistance`().
    Specified by:
      `jump` in interface `RandomGenerator.JumpableGenerator`
    Implementation Requirements:
      The default implementation invokes jump(jumpDistance()).

  - ### jumps

    default Stream<RandomGenerator.ArbitrarilyJumpableGenerator> jumps(double distance)
    Returns an effectively unlimited stream of new pseudorandom number generators, each of which implements the `RandomGenerator.ArbitrarilyJumpableGenerator` interface, produced by jumping copies of this generator by different integer multiples of the specified jump distance.
    Implementation Requirements:
      The default implementation is equivalent to `jumps` (`Long.MAX_VALUE`).
    Parameters:
      `distance` - a distance to jump forward within the state cycle
    Returns:
      a stream of objects that implement the `RandomGenerator` interface
    Throws:
      `IllegalArgumentException` - if `distance` is not greater than or equal to 0.0, or is greater than the period of this generator

  - ### jumps

    default Stream<RandomGenerator.ArbitrarilyJumpableGenerator> jumps(long streamSize, double distance)
    Returns a stream producing the given `streamSize` number of new pseudorandom number generators, each of which implements the `RandomGenerator.ArbitrarilyJumpableGenerator` interface, produced by jumping copies of this generator by different integer multiples of the specified jump distance.
    Implementation Requirements:
      The default implementation is equivalent to jumps(distance).limit(streamSize).
    Parameters:
      `streamSize` - the number of generators to generate
      `distance` - a distance to jump forward within the state cycle
    Returns:
      a stream of objects that implement the `RandomGenerator` interface
    Throws:
      `IllegalArgumentException` - if `streamSize` is less than zero or if `distance` is not greater than or equal to 0.0, or is greater than the period of this generator

  - ### leap

    default void leap()
    Alter the state of this pseudorandom number generator so as to jump forward a very large, fixed distance (typically 2128 or more) within its state cycle. The distance used is that returned by method `leapDistance`().
    Specified by:
      `leap` in interface `RandomGenerator.LeapableGenerator`

  - ### copyAndJump

    default RandomGenerator.ArbitrarilyJumpableGenerator copyAndJump(double distance)
    Copy this generator, jump this generator forward, then return the copy.
    Implementation Requirements:
      The default implementation copies this, jumps(distance) and then returns the copy.
    Parameters:
      `distance` - a distance to jump forward within the state cycle
    Returns:
      a copy of this generator object before the jump occurred
    Throws:
      `IllegalArgumentException` - if `distance` is not greater than or equal to 0.0, or is greater than the period of this generator